#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
extern void tvtls_();
#define InverseCDFGamma(prob,alpha,beta) InverseCDFChi2(prob,2.0*(alpha))/(2.0*(beta))
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
#ifndef PI
   #define PI 3.14159265358979323846
#endif
void seq_genc(int smodel, int ntaxa, double *utreec, int nsite, int *seq, 
	      int nrate, double alpha, int iseed, double *fr, double *Qk);
void aBPf_fast(int nBP, double *BP, int ntaxa, double *utreec,
	       int ns, int *s,
	       int nchar, int smodel, double *fr, double *Qk,
	       int nrate, double *rate, double *wt,
	       int tinfo, int nsite, int *seq,
	       int nsim, int condl, int iseed, int ismle, double *aBP);
void aBPuf_fast(double *BP, int ntaxa, double *utreec,
		int nchar, int smodel, double *fr, double *Qk,
		int nrate, double *rate, double *wt,
		int tinfo, int nsite, int *seq,
		int nsim, int condl, int iseed, int ismle, double *aBP);
char *aBPlf(FILE *treefile, FILE *seqfile, int ntaxa, 
	    int nchar, int smodel, double *fr, double *Qk, 
	    int nrate, double *rate, double *wt,
	    int tinfo, int nsite,
	    int nsim, int condl, int iseed, int ismle);
void aBP_paramf(FILE *fp, FILE **bpfile, FILE **utreecfile, FILE **treefile, 
		FILE **frfile, FILE **Qfile, FILE **ratefile, FILE **seqfile, 
		char *aaRmat, int *nBP, int *ntaxa, int *nchar, int *model, 
		int *tinfo, int *ncatG, int *nrate, int *nsim, int *iseed, 
		int *nsite, double *kappa, double *alpha, int *ismle);
FILE *fopene(char *filename, char *rw, char *err);
char ctl_paraml(FILE *fp, char *opt, char *value, int *is_option);
int pmodel2smodel(int model, char *aaRmat, int nchar);
void forward_probsbz(int nchar, int ntaxa, int s, double *utreec, double *M, 
		     double *f, double *zf);
void backward_probsbz(int nchar, int ntaxa, int s, double *utreec, double *M, 
		      double *zf, double *zb);
void lik_deriv_calcbz(int nchar, int ntaxa, int s, int *seq, double *fr, 
		      double *utreec, double *Mp, double *f, double *b, 
		      double *lp);
void lik_deriv_topz(int nchar, int ntaxa, int s, int p, double *fr, 
		      double *utreec, 
		      double *Mpz, double *f, double *b, double *lp);
void ederivz(int nchar, int ntaxa, int *seq, double *fr, 
	       double *utreec, double *M, double *Mp, double *Mpz, 
	       int ns, int *s, double *lp, double *px);
void infomxz(int nchar, int ntaxa, int *seq, double *fr, double *utreec, 
	       int nrate, double *wt, double *M, double *Mp, double *Mpz,
	       int ns, int *s, double *infos, double *px);
void transz(int nchar, int ntaxa, double *utreec, 
	    int nrate, double *rate, double *wt,
	    double *fr, double *W, double *Lam,		      
	    double pij(int i, int j, double t, int nchar, 
		       double *fr, double *W, double *Lam),
	    double ppij(int i, int j, double t, int nchar, 
			double *fr, double *W, double *Lam),
	    double *M, double *Mp, double *Mpz);
void symfillmat(int n, double *a);
void infomatrixz(int ntaxa, double *utreec, int ns, int *s,
		 int nchar, int smodel, double *fr, double *Qk, 
		 int nrate, double *rate, double *wt,
		 int tinfo, int nsite, int *seq, double *infom, 
		 int iseed);
int l2i(char c);
int l2ip(char c);
int rseqf(FILE *fp, char *seq);
char ignore_whitespace_seqfile(FILE *infile);
int rinterleave_block(FILE *infile, int numsp, int nsite, char name[][11], 
		       char *seq, int *initb);
void rinterleavef_nolim(FILE *infile, const int *numsp, const int *nsite, 
			char name[][11], char *seq);
int patt_freq(int numsp, int nsite, int *seq, int *count);
int all_sitepatt(int nchar, int ntaxa, int *patt);
void makeprotfreqs(double *fr, double *W, double *Lam);
void WLamfr2exchange(int nchar, double *W, double *Lam, double *fr, double *R);
void chQ_freq(int nbin, double *W, double *Lam, double *fr, double *fro);
double pijJCg(int x, int y, double t, int nchar);
double pijJCg_gen(int x, int y, double t, int nchar, double *fr, double *W, 
		  double *Lam);
double ppijJCg(int x, int y, double t, int nchar);
double ppijJCg_gen(int x, int y, double t, int nchar, double *fr,
		   double *W, double *Lam);
double pp2ijJCg(int x, int y, double t, int nchar);
double muF81f(int nchar, double *fr);
double pijF81(int i, int j, double t, int nchar, double mu, double *fr);
double pijF81_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *Lam);
double ppijF81(int i, int j, double t, int nchar, double mu, double *fr);
double ppijF81_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		   double *Lam);
int is_transitionf(int i, int j);
double muF84f(double K, double *fr);
double pijF84(int i, int j, double t, double mu, double K, double *fr);
double pijF84_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *K);
double ppijF84(int i, int j, double t, double mu, double K, double *fr);
double ppijF84_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *K);
double tt2K(double R, double *fr);
double K2tt(double K, double *fr);
double muHKYf(double kappa, double *fr);
double pijHKY(int i, int j, double t, double mu, double kappa, double *fr);
double pijHKY_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		  double *kappa);
double ppijHKY(int i, int j, double t, double mu, double kappa, double *fr);
double ppijHKY_gen(int i, int j, double t, int nchar, double *fr, double *mu,
		   double *kappa);
double tt2kappa(double R, double *fr);
double kappa2tt(double kappa,  double *fr);
void Q2frWLam(int nbin, double *Q, double *fr, double *W, double *Lam);
double pijGTR(int i, int j, double t, int nchar, double *fr, double *W, 
	      double *Lam);
double ppijGTR(int i, int j, double t, int nchar, double *fr, double *W, 
	       double *Lam);
int subst_model_set(int nchar, int smodel, double *fr, double *Qk, 
		    double (*(*pij))(int i, int j, double t, int nchar, 
				     double *fr, double *W, double *Lam),
		    double (*(*ppij))(int i, int j, double t, int nchar, 
				      double *fr, double *W, double *Lam),
		    double **W, double **Lam);
int subst_model_setp(int smodel,
		     double (*(*pij))(int i, int j, double t, int nchar,
				     double *fr, double *W, double *Lam),
		     double (*(*ppij))(int i, int j, double t, int nchar,
				       double *fr, double *W, double *Lam));
int subst_model_setparam(int nchar, int smodel, double *fr, double *Qk,
			 double **W, double **Lam);
void trans_gen(int nchar, int ntaxa, double *utreec, double *fr, double *W, 
	       double *Lam, 		      
	       double pij(int i, int j, double t, int nchar, 
			  double *fr, double *W, double *Lam),
	       double ppij(int i, int j, double t, int nchar, 
			     double *fr, double *W, double *Lam),
	       double *M, double *Mp);
void trans_gen_rate(int nchar, int ntaxa, double *utreec, 
		    int nrate, double *rate, double *wt,
		    double *fr, double *W, double *Lam, 		      
		    double pij(int i, int j, double t, int nchar, 
			       double *fr, double *W, double *Lam),
		    double ppij(int i, int j, double t, int nchar, 
				double *fr, double *W, double *Lam),
		    double *M, double *Mp);
void covscorecor(int ntaxa, double *infom, double *Sc);
void corscorecor(int ntaxa, double *infom, double *Sc, double *Ic);
double BPsf(double *V, double *Sc, int condl);
int mle1f(double *V);
int bpnf(int nsim, double *rho, double *BP, int condl, int ismle);
int eigenRealSym(double A[], int n, double Root[], double Offdiag[]);
void EigenSort(double d[], double U[], int n);
void HouseholderRealSym(double a[], int n, double d[], double e[]);
int EigenTridagQLImplicit(double d[], double e[], int n, double z[]);
double dot(int n, double *u, int incu, double *v, int incv);
void rnorm(int n, double *v, double *se);
double urand(void);
int chol(int m, double *l);
void cholf(int m, double *l, double *b);
void cholh(int m, double *l, double *b);
int lstring(char * string);
void backward_probb(int nchar, int r, double *M, double *f, double *bk,
		   double *b);
void backward_probsb(int nchar, int ntaxa, double *utreec, double *M, double *f, 
		    double *b);
void forward_probsb(int nchar, int ntaxa, int *s, double *utreec, double *M, 
		   double *f);
double lik_deriv_tedge(int nchar, int s, double *fr, double *bk, double *fl, 
		       double *Mp);
double lik_deriv_iedge(int nchar, double *fr, double *bk, double *fl, 
		     double *fc1, double *fc2, double *Mp);
int sqrtmat(int m, double *A, double *Ah);
void rmvnorm(int nsim, int m, double *mu, double *Sigma, double *V);
int DiscreteGamma (double freqK[], double rK[], double alpha, double beta, int K, int dgammamean);
void error2 (char * message);
long factorial (int n);
double LnGamma (double x);
double InverseCDFNormal (double prob);
double InverseCDFChi2 (double prob, double v);
double IncompleteGamma (double x, double alpha, double ln_gamma_alpha);
void parent_branch(int r, int ntaxa, double *utreec, int *p, int *l, 
		   double *bl, double *br);
void relab_int(int ntaxa, double *utreec, double *nutreec);
void rert(int r, int ntaxa, double *utreec, double *nutreec);
void rmexspce(int numsp, char names[][11]);
int ndig_intpart(double f);
char *ut2in(int numsp, double *utreec, char names[][11], char **ilabels);
void ut2n(int numsp, double *utreec, char names[][11], char *tstr);
int read_tree(FILE *fp, char *tstring);
double get_dlist(char *tstr, int ss, int de, int *ssn, int *ls, int *le);
void underscore2blank(char *s);
char **treecs(int ntaxa, char *tstr, char names[][11], double *utreec, 
	      int has_names);
char **read_treecs(FILE *treefile, int ntaxa, char names[][11], double *utreec, 
		   int has_names);
void split_leading1(int numsp, int *split);
void utreec2splits(int numsp, double *utreec, int *splits);
int ivsame(int n, int *x, int *y);
enum {
  alanine = 0, arginine, asparagine, aspartic, cysteine, 
  glutamine, glutamic, glycine, histidine, isoleucine,
  leucine, lysine, methionine, phenylalanine, proline,
  serine, threonine, tryptophan, tyrosine, valine
};
