#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "aBPn_fn.h"
int main(int argc, char **argv)
{
  FILE *fp,*treefile,*frfile,*Qfile,*ratefile,*seqfile,*bpfile,*utreecfile;
  char aaRmat[80],*tstr;
  int nBP,ntaxa,nchar,model,tinfo,ncatG,nrate,nsim,iseed,nsite,ismle,i,j;
  int smodel,condl=1;
  double kappa,alpha,*fr,*Qk,*rate,*wt,one=1.0;

  fp=fopen(argv[--argc],"r");
  aBP_paramf(fp,&bpfile,&utreecfile,&treefile,&frfile,&Qfile,&ratefile,&seqfile,
	     aaRmat,&nBP,&ntaxa,&nchar,&model,&tinfo,&ncatG,&nrate,&nsim,
	     &iseed,&nsite,&kappa,&alpha,&ismle);
  fclose(fp);
  smodel=pmodel2smodel(model,aaRmat,nchar);

  /* frequencies */
  fr = (double *) malloc((size_t) nchar*sizeof(double));
  if ((*aaRmat=='\0' && smodel != 0 && smodel != 3) || 
      (*aaRmat!='\0' && model==3)){ 
    for(i = 0; i < nchar; i++) fscanf(frfile,"%lf",&fr[i]);
  }
  if (*aaRmat!='\0' && model==2) *fr=-1;

  /* K for F84, kappa for HKY */
  if(smodel==2 || smodel==8) Qk=&kappa;

  /* Q matrix for GTR */
  if (smodel == 3){
    Qk = (double *) malloc((size_t) nchar*nchar*sizeof(double));
    for(i = 0; i < nchar; i++) 
      for(j = 0; j < nchar; j++) fscanf(Qfile,"%lf",&Qk[i+j*nchar]);
  }

  /* Rate Distribution */
  if (alpha > 0) nrate=ncatG;
  if (nrate==1){ rate=&one; wt=&one; }
  if (nrate > 1){
    rate = (double *) malloc((size_t) nrate*sizeof(double));
    wt = (double *) malloc((size_t) nrate*sizeof(double));
  }
  if (alpha > 0) rate[0]=-alpha;
  if (alpha < 0 && nrate > 1){
    for(i = 0; i < nrate; i++) fscanf(ratefile,"%lf %lf",&rate[i],&wt[i]);
  }

/*   fast_aBP=0; */
  tstr=aBPlf(treefile,seqfile,ntaxa,nchar,smodel,fr,Qk,nrate,rate,wt,tinfo,
	     nsite,nsim,condl,iseed,ismle);
  printf("%s\n",tstr);
  return(0);
}
